package org.example;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class Main {

    public static void main(String[] args) {
        helloWorld();

        System.out.println("This will appear in console!");

        int integerVar = 12345;
        char aSingleLetter = 'A';
        boolean trueOrFalse = true;
        String wordVar = "A bunch of text";

        int a = 1 + 2;
        int b = a - 1;
        int c = b * a;
        int d = c / 3;

        System.out.println(a + " : " + b + " : " + c + " : " + d);

        float mpg = milesPerGallon(65, 1.96F);
        System.out.println(mpg);

        boolean condition = true;

        if (condition) {
            System.out.println("condition is true");
        }

        if (condition) {
            System.out.println("condition is true");
        } else {
            System.out.println("condition is false");
        }

        int intCondition = 1;

        if (intCondition == 0) {
            System.out.println("The condition matches this first case");
        } else if (intCondition == 1) {
            System.out.println("The condition matches a different case");
        } else {
            System.out.println("The condition did not match any previous case");
        }

        int time = secondsCompressor(2837);
        System.out.println(time);

        int whileI = 0;
        boolean whileBool = true;
        while (whileBool) {
            System.out.println("This is looping!");
            whileI++;
            if (whileI > 5) {
                whileBool = false;
            }
        }

        doublePennies(30);

        float retailPrice = calculateRetail(5.00F, 100);
        System.out.println(retailPrice);

        Person me = new Person("Steven", "123 Main Street", 17, 7175558700L);
        System.out.println(me);

        Person friend = new Person("Bob", "123 Center Street", 18, 7175559900L);
        System.out.println(friend);

        Person family = new Person("John", "123 Main Street", 15, 7175558600L);
        System.out.println(family);

        Person[] people = new Person[3];
        people[0] = me;
        people[1] = friend;
        people[2] = family;

        for (Person person : people) {
            System.out.println(person);
        }
        //for (int i = 0; i < people.length; i++) {
        //    System.out.println(people.get(i));
        //}

        System.out.println(averageAges(people));

        TestChargeVerifier.main(new String[0]);
    }

    public static void helloWorld() {
        System.out.println("Hello, World!");
    }

    /**
     * returns value formatted to 1 decimal place
     */
    public static float milesPerGallon(int miles, float fuelUsed) {
        String value = new DecimalFormat("0.0").format(miles / fuelUsed);
        return Float.parseFloat(value);
    }

    /**
     * Takes seconds and converts them to minutes hours and days if the value is greater than 1
     */
    public static int secondsCompressor(int seconds) {
        if (seconds < 60) {
            return seconds;
        } else if (seconds < 3600) {
            return Math.round(seconds / 60F);
        } else if (seconds < 86400) {
            return Math.round(seconds / 3600F);
        } else {
            return Math.round(seconds / 86400F);
        }
    }

    /**
     * Don't pass anything higher than 64 days, java can't store longs greater than (insert large number) (i couldnt be bothered to look it up)
     */
    public static void doublePennies(int days) {
        if (days < 0) {
            return;
        }

        if (days > 64) {
            return;
        }

        long pennies = 1L;

        for (int i = 0; i < days; i++) {
            pennies *= 2;
            System.out.println("Day " + (i + 1) + ": " + (pennies / 100D));
        }
    }

    /**
     * Receives the wholesale and markup and returns retail
     * @param wholeSale wholesale cost in dollar amount
     * @param markup markup as a percentage
     * @return float dollar amount rounded as X.XX
     */
    public static float calculateRetail(float wholeSale, int markup) {
        float preRounded = wholeSale * (markup / 100F);
        String roundedString = new DecimalFormat("0.00").format(preRounded);
        return Float.parseFloat(roundedString);
    }

    public static float averageAges(Person[] people) {
        float ageTotal = 0;
        float numOfPeople = 0;

        for (Person person : people) {
            ageTotal += person.getAge();
            numOfPeople++;
        }

        return ageTotal / numOfPeople;
    }
}
